package me.sergiotarxz.bv;

import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.event.entity.*;
import org.bukkit.entity.*;
import org.bukkit.event.player.*;
import org.bukkit.event.EventHandler;
import java.util.logging.Level;
import org.bukkit.event.Listener;
import org.bukkit.persistence.*;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.UUID;
import org.bukkit.NamespacedKey;
import org.bukkit.metadata.MetadataValue;
import de.tr7zw.changeme.nbtapi.*;
import de.tr7zw.changeme.nbtapi.iface.*;
import org.bukkit.ChatColor;

public class BetterVillager extends JavaPlugin implements Listener {
    @Override
    public void onDisable() {
        // Don't log disabling, Spigot does that for you automatically!
    }

    @Override
    public void onEnable() {
	if (!NBT.preloadApi()) {
	    getLogger().warning("NBT-API wasn't initialized properly, disabling the plugin");
	    getPluginLoader().disablePlugin(this);
	    return;
	}
        getServer().getPluginManager().registerEvents(this, this);
    }


    @EventHandler
    public void onAsyncPlayerChatEvent(AsyncPlayerChatEvent event) {
        String message = event.getMessage();
        char[] messageArrayChars = message.toCharArray();

        String finalMessage = "";
        boolean isEscape = false;
        for (char c : messageArrayChars) {
            if (c == '&') {
                isEscape = true;
                continue;
            }
            if (isEscape) {
                if (c >= '0' && c <= '9') {
                    finalMessage += "§"+c;
                    isEscape = false;
                    continue;
                }
                isEscape = false;
            }
            finalMessage += c;
        }
        event.setMessage(finalMessage);
    }

    /** Event handler for when a player right-clicks on an entity. */
    @EventHandler
    public void onEntityInteraction(PlayerInteractEntityEvent event) {
        if (event == null || event.isCancelled()) {
            return;
        }
        Entity entity = event.getRightClicked();
        Player player = event.getPlayer();
        UUID playerUUID = player.getUniqueId();
        if (!(entity instanceof Villager)) {
            return;
        }
        Villager villager = (Villager) entity;
        getLogger().log(Level.INFO, "Listing villager keys");
	// {Target:[I;-595241863,-91010251,-1338114026,1482075547],Type:"major_positive",Value:20}
	NBT.modify(villager, nbt -> {
	    ReadWriteNBTCompoundList gossips = nbt.getCompoundList("Gossips");
            ReadWriteNBT currentPlayerGossip = null;
            int maxValueGossip = 0;
	    for (int i = 0; i < gossips.size(); i++) {
		ReadWriteNBT gossip = gossips.get(i);
		if (!gossip.getString("Type").equals("major_positive")) {
                    continue;
		}
                int value = gossip.getInteger("Value").intValue();
                if (maxValueGossip < value) {
                    maxValueGossip = value;
                }
                if (playerUUID.equals(gossip.getUUID("Target"))) {
                    currentPlayerGossip = gossip;
                }
		getLogger().log(Level.INFO, gossip.toString());
	    }
            if (maxValueGossip <= 0) {
                return;
            }
            if (currentPlayerGossip == null) {
                currentPlayerGossip = gossips.addCompound();
            }
            currentPlayerGossip.setUUID("Target", playerUUID);
            currentPlayerGossip.setInteger("Value", new Integer(maxValueGossip));
            currentPlayerGossip.setString("Type", "major_positive");
	});
    }
}
